=== debian/changelog ===
springlobby (0.194-2) unstable; urgency=medium

  * Switch back to wxwidgets3.0 (Closes: #751362)
    - Build with wxwidgets3.0 again since the archive migrates to this version
      before the freeze.
  * debian/rules: Disable wxwidgets3.0 assertions by using -DNDEBUG.

 -- Markus Koschany <apo@gambaru.de>  Fri, 13 Jun 2014 17:00:34 +0200

springlobby (0.194-1) unstable; urgency=medium

  * Imported Upstream version 0.194.
    - Fix version string is "unknown".
    - Fix wrong download paths without the / delimiter.
  * Remove override for dh_auto_configure.
    - Defining SPRINGLOBBY_REV is no longer necessary. The upstream build system
      handles that at build-time.
  * Build-depend on libboost-all-dev instead of single boost libraries.
    - Add additional boost libraries for the test suite. This also helps to
      avoid missing such dependencies in the future.
  * Switch back to libwxgtk2.8-dev. WxWidgets2.8 is more stable and supported
    by upstream.
  * Remove reference to /etc/spring/datadir in man pages.

 -- Markus Koschany <apo@gambaru.de>  Thu, 22 May 2014 12:04:18 +0200

springlobby (0.189-1) unstable; urgency=medium

  * Imported Upstream version 0.189.
    - Make it possible to change the path to the spring executable again.
      Thanks to Luca Ganzerla and Stefanie Dargel for the report.
      (Closes: #746502)

 -- Markus Koschany <apo@gambaru.de>  Sun, 04 May 2014 15:00:14 +0200

springlobby (0.185-1) unstable; urgency=medium

  * Imported Upstream version 0.185.
    - GPL-3+ files were relicensed to GPL-2+. Clarify that springlobby is
      distributed under GPL-2+. (Closes: #739058)
  * Rewrite debian/copyright file for new release 0.182. Add missing licenses.
  * Add myself to Uploaders.
    - Remove Jan and Marco. Thanks for your past work. (Closes: #737415)
  * debian/control:
    - Versioned b-d for debhelper is >= 9.
    - Declare compliance for Debian Policy 3.9.5.
    - Use canonical VCS-fields.
    - springlobby: Depend on spring >= 96.0.
    - Drop versioned b-d on dpkg-dev. Not needed.
    - Switch to libwxgtk3.0-dev.
    - Remove Provides: spring-lobby. Obsolete.
  * debian/rules:
    - Remove override dh_installchangelogs.
    - Improve debian/rules formatting.
    - Do not remove non-existent gitattributes directory.
    - Build with --parallel.
    - Do not compress README THANKS manually.
      This is automatically done by dh_compress.
    - Export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed.
  * debian/watch: Make the extension regex more flexible.
  * Drop README.Debian since it contains obsolete information.
  * Install binaries with springlobby.install file.
  * wrap-and-sort -sa.
  * Add springlobby.menu and springlobby.xpm generated from springlobby.svg.

 -- Markus Koschany <apo@gambaru.de>  Tue, 25 Mar 2014 22:38:20 +0100
